﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ParallelUtil;
using System.Threading.Tasks;
using System.Threading;
using System.Diagnostics;

namespace TestAffinityApp
{

    /// <summary>
    ///  Seems a hard thing to write a test to make sure you are selecting real cores as opposed to hyperthreading cores
    ///  Ive written this app to observe what happens, when I switch off hyper threading decection in the Cores class for thread affinity two cores
    ///  goes no quicker than one, turn it on and we see in task manager that with two cores two cores are pegged at 100% cpu and the time
    ///  is halfed.
    /// </summary>
    class Program
    {
        static void Main(string[] args)
        {


            for (int nCores = 1; nCores <= Cores.Max; nCores++)
            {
                Cores.CoresInUse = nCores;

                Stopwatch timer = Stopwatch.StartNew();



                Task[] tasks = new Task[4];
                for (int nTask = 0; nTask < tasks.Length; nTask++)
                {
                    tasks[nTask] = Task.Factory.StartNew(() =>
                        {
                            Thread.SpinWait(1000000000);
                        });
                }

                Task.WaitAll(tasks);


                Console.WriteLine("4 Tasks n Cores {0} took {1}", nCores, timer.Elapsed);
            }
        }
    }
}
