﻿using ParallelUtil;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Collections.Generic;

namespace TestParallelUtils
{
    
    
    /// <summary>
    ///This is a test class for RangeTest and is intended
    ///to contain all RangeTest Unit Tests
    ///</summary>
    [TestClass()]
    public class RangeTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///A test for ToString
        ///</summary>
        [TestMethod()]
        public void ToStringTest()
        {
            Range target = new Range(5,100); // TODO: Initialize to an appropriate value
            string expected = "5 - 100"; // TODO: Initialize to an appropriate value
            string actual;
            actual = target.ToString();
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///A test for CreateSubRanges
        ///</summary>
        [TestMethod()]
        public void CreateUniformSubRangesTest()
        {
            Range range = new Range(1, 100);

            int total = 0;
            foreach (Range subRange in range.CreateSubRanges(10))
            {
                Assert.AreEqual(10, 1 + (subRange.End - subRange.Start));
                total += 1 + (subRange.End - subRange.Start);
            }

            Assert.AreEqual(100, total);
        }

        [TestMethod()]
        public void CreateNonUniformSubRangesTest()
        {
            Range range = new Range(1, 16);

            int total = 0;
            foreach (Range subRange in range.CreateSubRanges(3))
            {
                total += 1 + (subRange.End - subRange.Start);
            }

            Assert.AreEqual(16, total);
        }

        /// <summary>
        ///A test for Range Constructor
        ///</summary>
        [TestMethod()]
        public void RangeConstructorTest()
        {
            int start = 1; // TODO: Initialize to an appropriate value
            int end = 10; // TODO: Initialize to an appropriate value
            Range target = new Range(start, end);
            Assert.AreEqual(1, target.Start);
            Assert.AreEqual(10, target.End);
        }
    }
}
