﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using ParallelUtil;

namespace TestParallelUtils
{
    [TestClass]
    public class TestSequences
    {
        [TestMethod]
        public void TestIntegerSequence()
        {
            int total = 0;
            foreach (int i in new IntegerSequence(0, 10,2))
            {
                total += i;
            }

            Assert.AreEqual(30, total);
        }

        [TestMethod]
        public void TestDoubleSequence()
        {
            double total = 0;
            double expectedTotal = 0;
            for (double i = 0; i <= 10 ; i+= 0.5 )
            {
                expectedTotal += i;
            }
            foreach (double i in new DoubleSequence(0, 10, 0.5))
            {
                total += i;
            }

            Assert.AreEqual(expectedTotal, total);
        }
    }
}
